//Main Navigation
(function () {

    var $mainNav = $('#nav-container').children('ul'),
			optionsList = '<option value="" selected>Site Navigation...</option>';

    $mainNav.find('li').each(function () {
        var $this = $(this),
				$anchor = $this.children('a'),
				depth = $this.parents('ul').length - 1,
				indent = '';

        if (depth) {
            while (depth > 0) {
                indent += ' - ';
                depth--;
            }
        }
        optionsList += '<option value="' + $anchor.attr('href') + '">' + indent + ' ' + $anchor.text() + '</option>';
    }).end()
		  .after('<select id="nav-responsive">' + optionsList + '</select>');

    $('#nav-responsive').on('change', function () {
        window.location = $(this).val();
    });

})();

// When DOM is fully loaded
jQuery(document).ready(function ($) {

    /* ---------------------------------------------------------------------- */
    /*	Social
    /* ---------------------------------------------------------------------- */

    /* ================ TWEETS SCROLL ================ */
    yepnope({
        test: $(".tweets-list-container").length,
        yep: SkinScriptsPath + '/js/jquery.tweetscroll.js',
        callback: function () {
            $('.tweets-list-container').tweetscroll({
                username: 'wscnews',
                time: true,
                limit: 11,
                replies: true,
                position: 'append',
                date_format: 'style2',
                animation: 'slide_up',
                visible_tweets: 2
            });
        }
    });

    yepnope({
        test: $(".instagram-feed,.flickr-feed,.youtube-feed,.newsfeed,.pinterest-feed,.deviant-feed,.picasa-feed,.dribbble-feed").length,
        yep: SkinScriptsPath + '/js/socialstream.jquery.js',
        callback: function () {

            /* ================ INSTAGRAM FEED ================ */
            $('.instagram-feed').socialstream({
                socialnetwork: 'instagram',
                limit: 15,
                username: 'photographyplus'
            })

            /* ================ FLICKR FEED ================ */
            $('.flickr-feed').socialstream({
                socialnetwork: 'flickr',
                limit: 15,
                username: 'Mrky1'
            })

            /* ================ YOUTUBE FEED ================ */
            $('.youtube-feed').socialstream({
                socialnetwork: 'youtube',
                limit: 15,
                username: 'nettutsplus'
            })

            /* ================ NEWSFEED ================ */
            $('.newsfeed').socialstream({
                socialnetwork: 'newsfeed',
                limit: 15,
                username: ' http://feeds.feedburner.com/webdesignerdepot?format=xml'
            })

            /* ================ PINTEREST FEED ================ */
            $('.pinterest-feed').socialstream({
                socialnetwork: 'pinterest',
                limit: 15,
                username: 'vmrkela'
            })

            /* ================ DEVIANT ART FEED ================ */
            $('.deviant-feed').socialstream({
                socialnetwork: 'deviantart',
                limit: 15,
                username: 'mrky-cro'
            })

            /* ================ PICASA FEED ================ */
            $('.picasa-feed').socialstream({
                socialnetwork: 'picasa',
                limit: 15,
                username: 'vmrkela1@gmail.com'
            })

            /* ================ DRIBBBLE FEED ================ */
            $('.dribbble-feed').socialstream({
                socialnetwork: 'dribbble',
                limit: 15,
                username: 'ElectricWizard'
            })
        }
    });

    /* ---------------------------------------------------------------------- */
    /*	Google Map
    /* ---------------------------------------------------------------------- */

    yepnope({
        test: $('#map_canvas').length,
        yep: SkinScriptsPath + '/js/jquery.gmap.min.js',
        callback: function () {

                $('#map_canvas').gMap({
                    address: 'Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia',
                    scrollwheel: false,
                    draggable: false,
                    zoom: 16,
                    markers: [
					{ 'address': 'Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia' }
				]
                });
        }
    });

    /* ---------------------------------------------------------------------- */
    /*	SLIDERS
    /* ---------------------------------------------------------------------- */

    //Variable number of visible items with variable sizes
    yepnope({
        test: $(".carousel-li.wsc-call-html").length,
        yep: SkinScriptsPath + '/js/jquery.carouFredSel-5.6.4-packed.js',
        callback: function () {
            $('.carousel-li.wsc-call-html').carouFredSel({
                items: 4,
                height: 161,
                prev: '.prev',
                next: '.next',
                auto: false,
                scroll: 1
            });
        }
    });



    /* AnythingSlider
    ----------------------------------------------------------------*/
    yepnope({
        test: $("#anything-slider .wsc-call-html").length,
        yep: {
            'anyslider': SkinScriptsPath + '/js/jquery.anythingslider.min.js',
            'fxmin': SkinScriptsPath + '/js/jquery.anythingslider.fx.min.js'
        },
        callback: {
            "fxmin": function () {
                $('#anything-slider #slides.wsc-call-html') // Using FX base effects 
                    .anythingSlider({
                        resizeContents: true,
                        expand: true,
                        buildArrows: true,
                        buildNavigation: true,
                        buildStartStop: false,
                        autoPlay: true,
                        delay: 5000
                    })
                    .anythingSliderFx({
                        // base FX definitions 
                        // '.selector' : [ 'effect(s)', 'size', 'time', 'easing' ] 
                        // 'size', 'time' and 'easing' are optional parameters, but must be kept in order if added 
                        '.panel1 .slide-img-container': ['left', '1040px', '1000', 'easeOutCirc'],
                        '.panel1 h3': ['right', '640px', '500', 'easeInOutCirc'],
                        '.panel1 p': ['right', '640px', '1000', 'easeInOutCirc'],
                        '.panel1 a': ['right', '640px', '1200', 'easeInOutCirc'],
                        '.panel2 .slide-img-container': ['bottom', '1040px', '1000', 'easeOutCirc'],
                        '.panel2 h3': ['top', '640px', '500', 'easeInOutCirc'],
                        '.panel2 p': ['top', '640px', '1000', 'easeInOutCirc'],
                        '.panel2 a': ['top', '840px', '1200', 'easeInOutCirc'],
                        '.panel3 blockquote': ['right', '640px', '100', 'easeInOutCirc'],
                        '.panel3 p': ['right', '640px', '1500', 'easeInOutCirc']
                    });

                $('#anything-slider .shadow-top, #anything-slider .shadow-bottom').remove();

            }

        }

    });

    /* NivoSlider
    ----------------------------------------------------------------*/
    yepnope({
        test: $("#slider.nivoSlider.wsc-call-html, #slider_thumb.wsc-call-html").length,
        yep: SkinScriptsPath + '/js/jquery.nivo.slider.pack.js',
        callback: function () {

            //Nivo slider
            $('#slider.nivoSlider.wsc-call-html').nivoSlider();

            //Nivo Thumb Slider
            $('#slider_thumb.wsc-call-html').nivoSlider({
                controlNavThumbs: true,
                effect: 'random' //"sliceDownRight","sliceDownLeft","sliceUpRight","sliceUpLeft","sliceUpDown","sliceUpDownLeft","fold","fade","boxRandom","boxRain","boxRainReverse","boxRainGrow","boxRainGrowReverse"
            });

        }
    });


    /* ================ For NivoSlider ================ */

    $('.nivo-caption h5, .nivo-caption .wsc-description').each(function () {
        if ($(this).html() == "")
            $(this).remove();
    });

    // Banner Pane
    $('.bannerPane').prepend('<div class="shadow-top"></div>').append('<div class="shadow-bottom"></div>');


    /* ---------------------------------------------------------------------- */
    /*	Switcher
    /* ---------------------------------------------------------------------- */
    yepnope({
        test: $("#style-switcher").length,
        yep: [SkinScriptsPath + '/js/jquery.cookie.js',
         SkinScriptsPath + '/js/switcher/styleSwitcher.js',
         SkinScriptsPath + '/js/switcher/styleSwitcher.css']
    });


    /* ---------------------------------------------------------------------- */
    /*	Other
    /* ---------------------------------------------------------------------- */

    /* ================ Search field ================ */

    /* Search field disappearing text 
    -------------------------------------------------------------------------------*/
    var initial = "Search...";
    var empty = "";
    $("#search .NormalTextBox").val(initial);
    $("#search .NormalTextBox").focus(function () {
        if ($(this).val() == initial) {
            $(this).val("");
        }
    }).blur(function () {
        if ($(this).val() == empty) {
            $(this).val(initial);
        }
    });

    /* ================ FeedbackForm ================ */

    if ($('div.FeedbackForm').length) {

        $('.FeedbackForm').addClass("use_form_styles");

        $('.Feedback_FieldLabel label span:even').css({ 'width': '0px' });

        $('.use_form_styles .Feedback_FieldLabel label span:even').css({ 'width': '0px' });

        $('.Feedback_Field input[id*=txtEmail], .Feedback_Field input[id*=txtName]').attr('value', '');

        var empty = "";
        $(".use_form_styles.FeedbackForm .Feedback_Field .dnnFormItem").each(function () {

            var holder = $(this).children("label").html();

            if ($(this).children("input, textarea").hasClass('dnnFormRequired'))
                holder += '*';
            if ($(this).children("input, textarea").val() == empty) {
                $(this).children("input, textarea").val(holder);
            }
            $(this).children("input, textarea").focus(function () {
                if ($(this).val() == holder) {
                    $(this).val("");
                }
            }).blur(function () {
                if ($(this).val() == empty) {
                    $(this).val(holder);
                }
            });
        });

    }





});










