$(document).ready(function () {

    var relativeDir = scriptsPathCustom + '/css/color_themes/';

    /* ***************************************
    * Reading Cookies for stored values
    *******************************************/
    styleInit();
    function styleInit() {
        if (readCookie("ssStyle") != null) {
            var styleVal = readCookie("ssStyle");
            changeStyle(styleVal);
        }

        if ((readCookie("ssPattern") != null) && ($('.boxed').hasClass('active'))) {
            var patternVal = readCookie("ssPattern");
            $('body').removeClass().addClass(patternVal);
        }
    }

    /* ***************************************
    * SlideIn and SlideOut animation on click
    *******************************************/

    $('#styles-button').on('click', function (e) {
        e.preventDefault();
        var switcherWidth = $('#style-switcher').width();
        if ($('#style-switcher').hasClass('opened')) {
            $('#style-switcher').animate({
                left: -switcherWidth
            }, 700, function () {
                $(this).removeClass('opened');
            });
        } else {
            $('#style-switcher').animate({
                left: 0
            }, 700, function () {
                $(this).addClass('opened');
            });
        }

    });

    /* ******************
    * Style Changing
    *********************/

    $('.styles-list li').on('click', function (e) {
        e.preventDefault();
        var styleVal = $(this).data("color");
        changeStyle(styleVal);
        createCookie("ssStyle", styleVal, 7);
    });

    /* ******************
    * Pattern Changing
    *********************/

    $('#pattern-list').on('change', function (e) {

        var patternVal = $(this).val();
        /* $('body').removeClass().addClass(patternVal);*/

        var patternDiv = $(".body_pattern");
        patternDiv.attr({ style: "" });
        patternDiv.css({ backgroundImage: "url(" + scriptsPathCustom + "/img/patterns/" + patternVal + ".png)" });

        createCookie("ssPattern", patternVal, 7);
    });

    $("#style-switcher a#no_pattern").on('click', function (e) {
        e.preventDefault();

        var patternDiv = $(".body_pattern");
        patternDiv.attr({ style: "" });
        patternDiv.css({ backgroundImage: "none" });

        var patternVal = '';
        createCookie("ssPattern", patternVal, 7);

    });


    /* ******************
    * Skin Changing
    *********************/

    //To Stretched
    $('.skin-list .streched a').on('click', function (e) {
        e.preventDefault();
        if ($('.wsc_wrap').hasClass('boxed')) {
            $('.wsc_wrap').removeClass('boxed body_pattern').addClass('stretched');
            $('.wsc_wrap.stretched').css({ backgroundImage: "none" });
            $('.bannerPane').addClass('body_pattern');
            $('.wsc_wrap.stretched > div').removeAttr('id');

        }
    });

    //To Boxed
    $('.skin-list .boxed a').on('click', function (e) {
        e.preventDefault();
        if ($('.wsc_wrap').hasClass('stretched')) {
            $('.wsc_wrap').removeClass('stretched').addClass('boxed body_pattern');
            $('.bannerPane').removeClass('body_pattern');
            $('.wsc_wrap.boxed > div').attr('id', 'page-wrap');
            $('.wsc_wrap.body_pattern').css({ backgroundImage: "url(" + scriptsPathCustom + "/img/patterns/pattern1.png)" });
        }
    });

    /* ******************
    * Pattern Menu Disable
    *********************/
    patternMenuDisable();
    function patternMenuDisable() {
        if ($('.streched').hasClass('active')) {
            $('#pattern-list').attr('disabled', true);
        }
    }

    function changeStyle(styleVal) {
        $('link[title="activestyle"]').remove();

        //replace the css with the current color to the chosen one
        var current = relativeDir + styleVal + ".css";
        var l = document.getElementById("current_style");
        l.href = current;

    }

    function createCookie(name, value, days) {
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            var expires = "; expires=" + date.toGMTString();
        }
        else var expires = "";
        document.cookie = name + "=" + value + expires + "; path=/";
    }

    function readCookie(name) {
        var nameEQ = name + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
        }
        return null;
    }

    function eraseCookie(name) {
        createCookie(name, "", -1);
    }
});

